Name:           asahi-platform-metapackage
Version:        0
Release:        7%{?dist}
Summary:        Metapackage declaring Asahi platform dependencies
Group:          Metapackages
License:        MIT
URL:            https://pagure.io/fedora-asahi/asahi-platform-metapackage
BuildArch:      noarch

BuildRequires:  systemd-rpm-macros
Requires:       %{name}-core = %{version}-%{release}
Requires:       (%{name}-audio = %{version}-%{release} if pipewire)
Requires:       (%{name}-plasma = %{version}-%{release} if plasma-desktop)
%dnl If/when we have desktop subpackages or whatever, we can make them
%dnl conditional dependencies with the following format:
%dnl Requires:       (%{name}-desktop-<variant> = %{version}-%{release} if <desktop-main-package>)

%description
This is a simple RPM package that defines the Asahi platform
software dependencies.

%files
%{_sysconfdir}/dnf/protected.d/%{name}.conf

%dnl -------------------------------------------------------------------

%package core
Summary:        Metapackage declaring core Asahi platform dependencies
Requires:       alsa-ucm-asahi
Requires:       asahi-fwextract
Requires:       dracut-asahi
Requires:       kernel-16k
Requires:       kernel-16k-modules-extra
Requires:       update-m1n1
Requires:       tiny-dfr
Recommends:     (widevine-installer if (chromium or firefox))
%dnl Block the 4k kernel
Conflicts:      kernel-core
Conflicts:      kernel-devel
Conflicts:      kernel-debug-core
Conflicts:      kernel-debug-devel
%dnl Block the 64k kernel
Conflicts:      kernel-64k-core
Conflicts:      kernel-64k-devel
Conflicts:      kernel-64k-debug-core
Conflicts:      kernel-64k-debug-devel

%description core
This package declares the core dependencies for the Asahi platform.

%files core
%dnl No files to ship

%dnl -------------------------------------------------------------------

%package audio
Summary:        Metapackage declaring audio support Asahi platform dependencies
Requires:       asahi-audio >= 0.5-1
Requires:       speakersafetyd >= 0.1.4-1
Conflicts:      pulseaudio

%description audio
This package declares the audio dependencies for the Asahi platform.

%files audio
%dnl No files to ship

%dnl -------------------------------------------------------------------

%package plasma
Summary:        Metapackage declaring Plasma desktop support Asahi platform dependencies
%dnl No deps at this time, just a temporary KWin workaround

%description plasma
This package declares the KDE Plasma dependencies for the Asahi platform.

%files plasma
%{_environmentdir}/50-asahi-plasma.conf

%dnl -------------------------------------------------------------------

%prep
%dnl Nothing to do

%build
%dnl Nothing to do

%install
# Install DNF protected package snippet to prevent it from being accidentally uninstalled
mkdir -p %{buildroot}%{_sysconfdir}/dnf/protected.d
echo "%{name}" > %{buildroot}%{_sysconfdir}/dnf/protected.d/%{name}.conf

# Workaround for KWin bug:
# https://bugs.kde.org/show_bug.cgi?id=477451
mkdir -p %{buildroot}%{_environmentdir}
echo 'KWIN_FORCE_SW_CURSOR=1' > %{buildroot}%{_environmentdir}/50-asahi-plasma.conf

%changelog
* Mon Dec 11 2023 Davide Cavalca <dcavalca@fedoraproject.org>
- Pull in widevine-installer if we have a supported browser

* Mon Nov 27 2023 Hector Martin <marcan@fedoraproject.org>
- Add plasma subpackage with KWin bug workaround

* Thu Nov 09 2023 Hector Martin <marcan@fedoraproject.org>
- Add audio subpackage

* Tue Nov 07 2023 Neal Gompa <ngompa@fedoraproject.org>
- Add protected packages configuration for DNF for this package

* Fri Nov 03 2023 Neal Gompa <ngompa@fedoraproject.org>
- Block 4k and 64k kernel-debug variants

* Wed Oct 04 2023 Neal Gompa <ngompa@fedoraproject.org>
- Block 4k and 64k kernel-devel variants

* Sat Sep 23 2023 Neal Gompa <ngompa@fedoraproject.org>
- Initial package
